#include <atmel_start.h>

int main(void)
{
	/* Initializes MCU, drivers and middleware */
	atmel_start_init();
	
	/* Initialise UART */
	
	struct io_descriptor *uart_io;
	usart_sync_get_io_descriptor(&USART_0, &uart_io);
	usart_sync_enable(&USART_0);
	
	/* Write Header */
	io_write(uart_io, (uint8_t *)"I2C Scanner\r\n", 13);
	
	/* Initialise I2C */
	
	struct io_descriptor *I2C_io;

	i2c_m_sync_get_io_descriptor(&I2C_0, &I2C_io);
	i2c_m_sync_enable(&I2C_0);
	

	/* Replace with your application code */
	while (1) {
		uint8_t error, address;
		int16_t nDevices;

		io_write(uart_io, (uint8_t *)"Scanning...\r\n", 13);
		nDevices = 0;
		for(address = 8; address < 120; address++ )
		{
			// The i2c_scanner uses the return value of
			// the Write.endTransmisstion to see if
			// a device did acknowledge to the address.
			Wire.beginTransmission(address);
			error = Wire.endTransmission();

			if (error == 0)
			{
				Serial.print("I2C device found at address 0x");
				if (address<16)
				Serial.print("0");
				Serial.print(address,HEX);
				Serial.println("  !");

				nDevices++;
			}
			else if (error==4)
			{
				Serial.print("Unknow error at address 0x");
				if (address<16)
				Serial.print("0");
				Serial.println(address,HEX);
			}
		}
		if (nDevices == 0)
		io_write(uart_io, (uint8_t *)"No I2C devices found\r\n\n", 23);
		else
		io_write(uart_io, (uint8_t *)"done\r\n\n", 7);
	
		delay(5000); // wait 5 seconds for next scan
		
		
	}
}
